import sys
import os
import re
import string
import time, datetime
import types
from sqlite3 import *

tel = {'':'Unknown Number'}

sms_type = {4098:"Inbox", 4101:"Sent Items"}

sms_db = 'PCCSSMS.db'
contact_db = 'PCCSContact.db'

CSIDL_APPDATA = 26

if len(sys.argv) < 2:
    print 'Usage with PC Suite: %s IMEI' % (sys.argv[0])
    print 'IMEI\'s detected on local computer:'
    for imei in os.listdir('%s\\PC Suite' % os.environ['APPDATA']):
        rx = re.compile('[0-9]{15}$')
        if type(rx.search(imei)) <> type(None):
            print '* %s' % imei
    print ''
        
    sys.exit('Usage with Backup DB: %s %s %s' % (sys.argv[0], sms_db, contact_db))
else:
    rx = re.compile('[0-9]{15}$')
    if type(rx.search(sys.argv[1])) <> type(None):
        imei = sys.argv[1]

        sms_db = '%s\\PC Suite\\%s\\%s' % (os.environ['APPDATA'], imei, sms_db)
        contact_db = '%s\\PC Suite\\%s\\%s' % (os.environ['APPDATA'], imei, contact_db)
    else:
        sms_db = sys.argv[1]
        if len(sys.argv) < 3:
            contact_db = ''
        else:
            contact_db = sys.argv[2]

if not os.path.exists(sms_db):
    sys.exit('ERROR: Database %s not exists' % sms_db)

if len(contact_db) <> 0:
    if not os.path.exists(contact_db):
        sys.exit('ERROR: Database %s not exists' % contact_db)
    else:
        conn = connect(contact_db)
        cursor = conn.cursor()

        prev_uid = 0
        prev_name = ''
        prev_number = ''

        cursor.execute('SELECT string_data.uid, field_subtype, text_data, number_modified FROM string_data INNER JOIN number_data ON string_data.uid = number_data.uid WHERE field_subtype = 2 OR field_subtype = 4 ORDER BY string_data.uid, number_modified, field_subtype')
        for data in cursor:
            uid = data[0]

            field_subtype = data[1]
            text_data = data[2].encode('utf-8')
            
            number = data[3]
            if type(number) is types.IntType or type(number) is types.LongType:
                number = str(number)
            elif type(number) is types.UnicodeType:
                number = number.encode('utf-8')

            if field_subtype == 2:
                if prev_uid == uid and prev_number == number:
                    continue
                else:
                    tel[prev_number] = prev_name

                    prev_uid = uid
                    prev_name = text_data
                    prev_number = number
            elif field_subtype == 4:
                if prev_uid == uid and prev_number == number:
                    if prev_name.endswith(' %s' % text_data):
                        continue
                    else:
                        prev_name = '%s %s' % (prev_name, text_data)
                else:
                    tel[prev_number] = prev_name

conn = connect(sms_db)
cursor = conn.cursor()

cursor.execute('SELECT folder_uid, binary_data FROM sms_data ORDER BY modified_time_stamp')
for data in cursor:
    folder_uid = data[0]
    
    folder = sms_type[folder_uid]
    if type(folder) is types.NoneType:
        continue
    
    blob_data = Binary(data[1])
    sms_data = unicode(blob_data).decode('utf-16')

    name = ''

    rx = re.compile('%N:([A-Za-z0-9 ]+)')
    telno = rx.search(sms_data)

    if type(telno) <> type(None):
        name = telno.group(1)
    else:
        rx = re.compile('TEL:([\\+0-9]+)')
        telno = rx.search(sms_data)

        if type(telno) is types.NoneType:
            continue

        for ent in tel:
            if telno.group(1).endswith(ent):
                name = tel[ent]

        if len(name) == 0:
            name = telno.group(1)

    rx = re.compile('Date:([0-9:\\. ]+)')
    date = rx.search(sms_data)

    if type(date) is types.NoneType:
        continue

    timedata = date.group(1)
    if type(timedata) is types.UnicodeType:
        timedata = timedata.encode('utf-8')

    try:
        timestamp = time.strptime(timedata, '%m.%d.%Y %H:%M:%S')
    except:
        timestamp = time.strptime(timedata, '%Y.%m.%d %H:%M:%S')

    file_name = '%s_%s' % (name, time.strftime('%Y-%m-%d', timestamp))

    if not os.path.exists(name):
        os.makedirs(name)

    file_path = '%s\\%s' % (name, folder)

    if not os.path.exists(file_path):
        os.makedirs(file_path)

    if os.path.exists('%s\\%s.vmg' % (file_path, file_name)):
        dup_iter = 1
        file_iter = '%s\\%s(%d).vmg' % (file_path, file_name, dup_iter)
        
        while os.path.exists(file_iter):
            dup_iter += 1
            file_iter = '%s\\%s(%d).vmg' % (file_path, file_name, dup_iter)

        file_path = file_iter
    else:
        file_path = '%s\\%s.vmg' % (file_path, file_name)

    print file_path

    file = open(file_path, 'wb')
    file.write(blob_data)
    file.close()
